# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/hornetq/hornetq-jopr-plugin/%{namedversion}-brew
%define maven2brewrepodir %{_javadir}/repository.jboss.com/maven2-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define reltag Final
%define namedversion %{version}.%{reltag}

Name:		hornetq-jopr-plugin
Summary: 	HornetQ JOPR plugin
Version: 	2.0.0
Release: 	0.%{reltag}.1%{dist}
Epoch:		0
License: 	LGPLv2+
Group: 		Development/Java
URL:		http://hornetq.org
# svn exsvn export https://anonsvn.jboss.org/repos/hornetq/projects/jopr-plugin/tags/HornetQ-jopr-plugin_2_0_0_Final/ hornetq-jopr-plugin_2_0_0_Final
#Exported revision 10230
# tar czf hornetq-jopr-plugin_2_0_0_Final.tar.gz hornetq-jopr-plugin_2_0_0_Final
Source0:    hornetq-jopr-plugin_2_0_0_%{reltag}.tar.gz
Source1:    %{name}-jpp-depmap.xml
Source2:	%{name}-component-info.xml
### FIXME: use tar ball until we have rhq & deps built in brew
#Source3:	%{name}-rhq.tar.gz
#Source4:	%{name}-hyperic-sigar.tar.gz
#Source5:	%{name}-i18nlog.tar.gz
# Align with EAP 5.1 deps
Patch0:	        %{name}-pom.patch
Patch1:         %{name}-version.patch

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-buildroot
BuildRequires:	java-devel
BuildRequires:	jboss-man >= 0:2.1.1
BuildRequires:	hibernate3-ejb-persistence-3.0-api >= 1:1.0.2
BuildRequires:	hibernate3-annotations >= 0:3.4.0
### FIXME:fix these BRs when we have rhq built
#BuildRequires:	org.rhq rhq-core-domain 1.4.0.B01
#BuildRequires:	org.rhq rhq-core-plugin-api 1.4.0.B01
#BuildRequires:	org.rhq rhq-jmx-plugin 1.4.0.B01
BuildRequires:	jboss-parent
## Cannot find parent: org.jboss:jboss-parent for project: org.jboss.integration:jboss-integration-parent:pom:5.1.0.SP1 for project org.jboss.integration:jboss-integration-parent:pom:5.1.0.SP1
BuildRequires:	jboss-integration >= 0:5.1.0
BuildRequires:	xml-commons-apis
#      1) org.hornetq:hornetq-jopr-plugin:jar:1.0.0.CR2
#        2) org.jboss.integration:jboss-profileservice-spi:jar:5.1.0.SP1
#        3) org.jboss.microcontainer:jboss-dependency:jar:2.0.6.GA
#        4) org.jboss:jbossxb:jar:2.0.1.GA
#        5) apache-xerces:xml-apis:jar:2.9.1
BuildRequires:	xerces-j2
#       1) org.hornetq:hornetq-jopr-plugin:jar:1.0.0.CR2
#        2) org.jboss.integration:jboss-profileservice-spi:jar:5.1.0.SP1
#        3) org.jboss.microcontainer:jboss-dependency:jar:2.0.6.GA
#        4) org.jboss:jbossxb:jar:2.0.1.GA
#        5) apache-xerces:xercesImpl:jar:2.9.1
BuildRequires:	codehaus-stax-api
#       1) org.hornetq:hornetq-jopr-plugin:jar:1.0.0.CR2
#        2) org.jboss.man:jboss-managed:jar:2.1.1.SP4
#        3) sun-jaxb:jaxb-api:jar:2.1.4
#        4) javax.xml.stream:stax-api:jar:1.0-2
BuildRequires:	jboss-transaction-1.0.1-api
#       1) org.hornetq:hornetq-jopr-plugin:jar:1.0.0.CR2
#        2) org.hibernate:hibernate-annotations:jar:3.4.0.GA_CP02
#        3) org.hibernate:hibernate-core:jar:3.3.2.GA_CP02
#        4) javax.transaction:jta:jar:1.1
BuildRequires:	hsqldb
#       1) org.hornetq:hornetq-jopr-plugin:jar:1.0.0.CR2
#        2) org.hibernate:hibernate-annotations:jar:3.4.0.GA_CP02
#        3) hsqldb:hsqldb:jar:1.8.0.2
BuildRequires:	gwt
#        1) org.hornetq:hornetq-jopr-plugin:jar:1.0.0.CR2
#        2) org.rhq:rhq-core-domain:jar:3.0.0.B06
#        3) com.google.gwt:gwt-user:jar:2.0.0


BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:	maven-buildmagic-thirdparty-plugin
BuildRequires:	maven-doxia-sitetools
BuildRequires:	maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:	maven2-plugin-install
BuildRequires:	maven2-plugin-jar
BuildRequires:	maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:	maven2-plugin-source
BuildRequires:	maven2-plugin-surefire
BuildRequires:	maven-surefire

BuildRequires:  rhq-jmx-plugin
BuildRequires:  rhq-common-parent
BuildRequires:  rhq-core-domain
BuildRequires:  rhq-core-parent
BuildRequires:  rhq-core-util
BuildRequires:  rhq-modules-parent
BuildRequires:  rhq-core-client-api
BuildRequires:  rhq-core-gui
BuildRequires:  rhq-core-plugin-api
BuildRequires:  rhq-jboss-as-common
BuildRequires:  rhq-parent
BuildRequires:  rhq-core-comm-api
BuildRequires:  rhq-core-native-system
BuildRequires:  rhq-core-plugin-container
BuildRequires:  rhq-platform-plugin
BuildRequires:  rhq-plugins-parent

BuildRequires:  org-mc4j-ems
BuildRequires:  sigar
BuildRequires:  i18nlog
BuildRequires:  slf4j

Requires:	jboss-man >= 0:2.1.1
Requires:	jboss-integration >= 0:2.1.1

%description
HornetQ JOPR plugin.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n hornetq-jopr-plugin_2_0_0_%{reltag}
%patch0 -p0
%patch1 -p0

export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL
pushd $MAVEN_REPO_LOCAL
#tar zxf %{SOURCE3}
#tar zxf %{SOURCE4}
#tar zxf %{SOURCE5}
popd


%build
export JAVA_HOME=/usr/lib/jvm/java
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install javadoc:javadoc

%install
# jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 644 target/%{name}.jar \
     $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.hornetq hornetq-jopr-plugin %{namedversion} JPP %{name}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# repolib
%if %{with_repolib}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	tag=`echo %{namedversion}-brew`
	sed -i "s/@VERSION@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
	tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
	sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
        cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
        cp -p target/%{name}.jar $RPM_BUILD_ROOT%{repodirlib}

(cd $RPM_BUILD_ROOT%{repodir}; %{_bindir}/mvn-jpp org.jboss.maven.plugins:maven-buildmagic-thirdparty-plugin:maven-deploy -Durl=file:///$RPM_BUILD_ROOT%{maven2brewrepodir} -DgroupId=org.hornetq -DartifactId=%{name} -Dversion=%{namedversion}; cd -)

%endif

%clean
rm -Rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}*jar
%{_datadir}/maven2/poms/JPP*%{name}*.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Fri Mar 25 2011 Tom Hauser <thauser@redhat.com> - 0:2.0.0-1.Final.0
- Upgrade to 2.0.0.Final. 
- Add patch to include version information in rhq-plugin.xml
- Add reltag dependant paths instead of hardcoded ones.

* Wed Dec 15 2010 Yong Yang <yyang@redhat.com> - 0:2.0.0-0.CR1.1
- Add BR slf4j

* Wed Dec 15 2010 Yong Yang <yyang@redhat.com> - 0:2.0.0-0.CR1.0
- Upgrade to 2.0.0.CR1
- Remove binary sources

* Thu Jun 24 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.0-0.CR2.0
- First release
